diff --git a/roms/ipxe/src/hci/tui/menu_ui.c b/roms/ipxe/src/hci/tui/menu_ui.c
new file mode 100644
index 0000000000000000000000000000000000000000..d5636f8b018e03101f969dad4820213cf27fdbda
--- /dev/null
+++ b/roms/ipxe/src/hci/tui/menu_ui.c
@@ -0,0 +1,370 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Menu interface
+ *
+ */
+
+#include <string.h>
+#include <errno.h>
+#include <curses.h>
+#include <ipxe/keys.h>
+#include <ipxe/timer.h>
+#include <ipxe/console.h>
+#include <ipxe/menu.h>
+#include <config/colour.h>
+
+/* Colour pairs */
+#define CPAIR_NORMAL	1
+#define CPAIR_SELECT	2
+#define CPAIR_SEPARATOR	3
+
+/* Screen layout */
+#define TITLE_ROW	1
+#define MENU_ROW	3
+#define MENU_COL	1
+#define MENU_ROWS	18
+#define MENU_COLS	78
+#define MENU_PAD	2
+
+/** A menu user interface */
+struct menu_ui {
+	/** Menu */
+	struct menu *menu;
+	/** Number of menu items */
+	int count;
+	/** Currently selected item */
+	int selected;
+	/** First visible item */
+	int first_visible;
+	/** Timeout (0=indefinite) */
+	unsigned long timeout;
+};
+
+/**
+ * Return a numbered menu item
+ *
+ * @v menu		Menu
+ * @v index		Index
+ * @ret item		Menu item, or NULL
+ */
+static struct menu_item * menu_item ( struct menu *menu, unsigned int index ) {
+	struct menu_item *item;
+
+	list_for_each_entry ( item, &menu->items, list ) {
+		if ( index-- == 0 )
+			return item;
+	}
+
+	return NULL;
+}
+
+/**
+ * Draw a numbered menu item
+ *
+ * @v ui		Menu user interface
+ * @v index		Index
+ */
+static void draw_menu_item ( struct menu_ui *ui, int index ) {
+	struct menu_item *item;
+	unsigned int row_offset;
+	char buf[ MENU_COLS + 1 /* NUL */ ];
+	char timeout_buf[6]; /* "(xxx)" + NUL */
+	size_t timeout_len;
+	size_t max_len;
+	size_t len;
+
+	/* Move to start of row */
+	row_offset = ( index - ui->first_visible );
+	move ( ( MENU_ROW + row_offset ), MENU_COL );
+
+	/* Get menu item */
+	item = menu_item ( ui->menu, index );
+	if ( item ) {
+
+		/* Draw separators in a different colour */
+		if ( ! item->label )
+			color_set ( CPAIR_SEPARATOR, NULL );
+
+		/* Highlight if this is the selected item */
+		if ( index == ui->selected ) {
+			color_set ( CPAIR_SELECT, NULL );
+			attron ( A_BOLD );
+		}
+
+		/* Construct row */
+		memset ( buf, ' ', ( sizeof ( buf ) - 1 ) );
+		buf[ sizeof ( buf ) -1 ] = '\0';
+		len = strlen ( item->text );
+		max_len = ( sizeof ( buf ) - 1 /* NUL */ - ( 2 * MENU_PAD ) );
+		if ( len > max_len )
+			len = max_len;
+		memcpy ( ( buf + MENU_PAD ), item->text, len );
+
+		/* Add timeout if applicable */
+		timeout_len =
+			snprintf ( timeout_buf, sizeof ( timeout_buf ), "(%ld)",
+				   ( ( ui->timeout + TICKS_PER_SEC - 1 ) /
+				     TICKS_PER_SEC ) );
+		if ( ( index == ui->selected ) && ( ui->timeout != 0 ) ) {
+			memcpy ( ( buf + MENU_COLS - MENU_PAD - timeout_len ),
+				 timeout_buf, timeout_len );
+		}
+
+		/* Print row */
+		printw ( "%s", buf );
+
+		/* Reset attributes */
+		color_set ( CPAIR_NORMAL, NULL );
+		attroff ( A_BOLD );
+
+	} else {
+		/* Clear row if there is no corresponding menu item */
+		clrtoeol();
+	}
+
+	/* Move cursor back to start of row */
+	move ( ( MENU_ROW + row_offset ), MENU_COL );
+}
+
+/**
+ * Draw the current block of menu items
+ *
+ * @v ui		Menu user interface
+ */
+static void draw_menu_items ( struct menu_ui *ui ) {
+	unsigned int i;
+
+	/* Jump scroll to correct point in list */
+	while ( ui->first_visible < ui->selected )
+		ui->first_visible += MENU_ROWS;
+	while ( ui->first_visible > ui->selected )
+		ui->first_visible -= MENU_ROWS;
+
+	/* Draw ellipses before and/or after the list as necessary */
+	color_set ( CPAIR_SEPARATOR, NULL );
+	mvaddstr ( ( MENU_ROW - 1 ), ( MENU_COL + MENU_PAD ),
+		   ( ( ui->first_visible > 0 ) ? "..." : "   " ) );
+	mvaddstr ( ( MENU_ROW + MENU_ROWS ), ( MENU_COL + MENU_PAD ),
+		   ( ( ( ui->first_visible + MENU_ROWS ) < ui->count ) ?
+		     "..." : "   " ) );
+	color_set ( CPAIR_NORMAL, NULL );
+
+	/* Draw visible items */
+	for ( i = 0 ; i < MENU_ROWS ; i++ )
+		draw_menu_item ( ui, ( ui->first_visible + i ) );
+}
+
+/**
+ * Menu main loop
+ *
+ * @v ui		Menu user interface
+ * @ret selected	Selected item
+ * @ret rc		Return status code
+ */
+static int menu_loop ( struct menu_ui *ui, struct menu_item **selected ) {
+	struct menu_item *item;
+	unsigned long timeout;
+	unsigned int delta;
+	int current;
+	int key;
+	int i;
+	int move;
+	int chosen = 0;
+	int rc = 0;
+
+	do {
+		/* Record current selection */
+		current = ui->selected;
+
+		/* Calculate timeout as remainder of current second */
+		timeout = ( ui->timeout % TICKS_PER_SEC );
+		if ( ( timeout == 0 ) && ( ui->timeout != 0 ) )
+			timeout = TICKS_PER_SEC;
+		ui->timeout -= timeout;
+
+		/* Get key */
+		move = 0;
+		key = getkey ( timeout );
+		if ( key < 0 ) {
+			/* Choose default if we finally time out */
+			if ( ui->timeout == 0 )
+				chosen = 1;
+		} else {
+			/* Cancel any timeout */
+			ui->timeout = 0;
+
+			/* Handle key */
+			switch ( key ) {
+			case KEY_UP:
+				move = -1;
+				break;
+			case KEY_DOWN:
+				move = +1;
+				break;
+			case KEY_PPAGE:
+				move = ( ui->first_visible - ui->selected - 1 );
+				break;
+			case KEY_NPAGE:
+				move = ( ui->first_visible - ui->selected
+					 + MENU_ROWS );
+				break;
+			case KEY_HOME:
+				move = -ui->count;
+				break;
+			case KEY_END:
+				move = +ui->count;
+				break;
+			case ESC:
+			case CTRL_C:
+				rc = -ECANCELED;
+				break;
+			case CR:
+			case LF:
+				chosen = 1;
+				break;
+			default:
+				i = 0;
+				list_for_each_entry ( item, &ui->menu->items,
+						      list ) {
+					if ( ! ( item->shortcut &&
+						 ( item->shortcut == key ) ) ) {
+						i++;
+						continue;
+					}
+					ui->selected = i;
+					if ( item->label ) {
+						chosen = 1;
+					} else {
+						move = +1;
+					}
+				}
+				break;
+			}
+		}
+
+		/* Move selection, if applicable */
+		while ( move ) {
+			ui->selected += move;
+			if ( ui->selected < 0 ) {
+				ui->selected = 0;
+				move = +1;
+			} else if ( ui->selected >= ui->count ) {
+				ui->selected = ( ui->count - 1 );
+				move = -1;
+			}
+			item = menu_item ( ui->menu, ui->selected );
+			if ( item->label )
+				break;
+			move = ( ( move > 0 ) ? +1 : -1 );
+		}
+
+		/* Redraw selection if necessary */
+		if ( ( ui->selected != current ) || ( timeout != 0 ) ) {
+			draw_menu_item ( ui, current );
+			delta = ( ui->selected - ui->first_visible );
+			if ( delta >= MENU_ROWS )
+				draw_menu_items ( ui );
+			draw_menu_item ( ui, ui->selected );
+		}
+
+		/* Record selection */
+		item = menu_item ( ui->menu, ui->selected );
+		assert ( item != NULL );
+		assert ( item->label != NULL );
+		*selected = item;
+
+	} while ( ( rc == 0 ) && ! chosen );
+
+	return rc;
+}
+
+/**
+ * Show menu
+ *
+ * @v menu		Menu
+ * @v wait_ms		Time to wait, in milliseconds (0=indefinite)
+ * @ret selected	Selected item
+ * @ret rc		Return status code
+ */
+int show_menu ( struct menu *menu, unsigned int timeout_ms,
+		const char *select, struct menu_item **selected ) {
+	struct menu_item *item;
+	struct menu_ui ui;
+	char buf[ MENU_COLS + 1 /* NUL */ ];
+	int labelled_count = 0;
+	int rc;
+
+	/* Initialise UI */
+	memset ( &ui, 0, sizeof ( ui ) );
+	ui.menu = menu;
+	ui.timeout = ( ( timeout_ms * TICKS_PER_SEC ) / 1000 );
+	list_for_each_entry ( item, &menu->items, list ) {
+		if ( item->label ) {
+			if ( ! labelled_count )
+				ui.selected = ui.count;
+			labelled_count++;
+			if ( select ) {
+				if ( strcmp ( select, item->label ) == 0 )
+					ui.selected = ui.count;
+			} else {
+				if ( item->is_default )
+					ui.selected = ui.count;
+			}
+		}
+		ui.count++;
+	}
+	if ( ! labelled_count ) {
+		/* Menus with no labelled items cannot be selected
+		 * from, and will seriously confuse the navigation
+		 * logic.  Refuse to display any such menus.
+		 */
+		return -ENOENT;
+	}
+
+	/* Initialise screen */
+	initscr();
+	start_color();
+	init_pair ( CPAIR_NORMAL, COLOR_NORMAL_FG, COLOR_NORMAL_BG );
+	init_pair ( CPAIR_SELECT, COLOR_SELECT_FG, COLOR_SELECT_BG );
+	init_pair ( CPAIR_SEPARATOR, COLOR_SEPARATOR_FG, COLOR_SEPARATOR_BG );
+	color_set ( CPAIR_NORMAL, NULL );
+	erase();
+
+	/* Draw initial content */
+	attron ( A_BOLD );
+	snprintf ( buf, sizeof ( buf ), "%s", ui.menu->title );
+	mvprintw ( TITLE_ROW, ( ( COLS - strlen ( buf ) ) / 2 ), "%s", buf );
+	attroff ( A_BOLD );
+	draw_menu_items ( &ui );
+	draw_menu_item ( &ui, ui.selected );
+
+	/* Enter main loop */
+	rc = menu_loop ( &ui, selected );
+	assert ( *selected );
+
+	/* Clear screen */
+	endwin();
+
+	return rc;
+}
diff --git a/roms/ipxe/src/hci/tui/settings_ui.c b/roms/ipxe/src/hci/tui/settings_ui.c
index ed076101fe019d79e219c034c878..403d12453e32ac818519fd6e0c80 100644
--- a/roms/ipxe/src/hci/tui/settings_ui.c
+++ b/roms/ipxe/src/hci/tui/settings_ui.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -28,6 +29,7 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #include <ipxe/editbox.h>
 #include <ipxe/keys.h>
 #include <ipxe/settings_ui.h>
+#include <config/colour.h>
 
 /** @file
  *
@@ -557,11 +559,11 @@ int settings_ui ( struct settings *settings ) {
 
 	initscr();
 	start_color();
-	init_pair ( CPAIR_NORMAL, COLOR_WHITE, COLOR_BLUE );
-	init_pair ( CPAIR_SELECT, COLOR_WHITE, COLOR_RED );
-	init_pair ( CPAIR_EDIT, COLOR_BLACK, COLOR_CYAN );
-	init_pair ( CPAIR_ALERT, COLOR_WHITE, COLOR_RED );
-	init_pair ( CPAIR_URL, COLOR_CYAN, COLOR_BLUE );
+	init_pair ( CPAIR_NORMAL, COLOR_NORMAL_FG, COLOR_NORMAL_BG );
+	init_pair ( CPAIR_SELECT, COLOR_SELECT_FG, COLOR_SELECT_BG );
+	init_pair ( CPAIR_EDIT, COLOR_EDIT_FG, COLOR_EDIT_BG );
+	init_pair ( CPAIR_ALERT, COLOR_ALERT_FG, COLOR_ALERT_BG );
+	init_pair ( CPAIR_URL, COLOR_URL_FG, COLOR_URL_BG );
 	color_set ( CPAIR_NORMAL, NULL );
 	erase();
 	
diff --git a/roms/ipxe/src/hci/wireless_errors.c b/roms/ipxe/src/hci/wireless_errors.c
index 63c6251c6388c1405cd4f4966cb9..7154df55656a41ffb2a60fc6b0ad 100644
--- a/roms/ipxe/src/hci/wireless_errors.c
+++ b/roms/ipxe/src/hci/wireless_errors.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/image/efi_image.c b/roms/ipxe/src/image/efi_image.c
index 0575496cbcf7c0feaceaad367adb..0368b82c4eb589ae4463a9906a12 100644
--- a/roms/ipxe/src/image/efi_image.c
+++ b/roms/ipxe/src/image/efi_image.c
@@ -13,19 +13,104 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
 
 #include <errno.h>
+#include <stdlib.h>
+#include <wchar.h>
 #include <ipxe/efi/efi.h>
+#include <ipxe/efi/efi_snp.h>
+#include <ipxe/efi/efi_download.h>
+#include <ipxe/efi/efi_file.h>
+#include <ipxe/efi/efi_driver.h>
+#include <ipxe/efi/efi_strings.h>
 #include <ipxe/image.h>
 #include <ipxe/init.h>
 #include <ipxe/features.h>
+#include <ipxe/uri.h>
 
 FEATURE ( FEATURE_IMAGE, "EFI", DHCP_EB_FEATURE_EFI, 1 );
 
+/** EFI loaded image protocol GUID */
+static EFI_GUID efi_loaded_image_protocol_guid =
+	EFI_LOADED_IMAGE_PROTOCOL_GUID;
+
+/**
+ * Create device path for image
+ *
+ * @v image		EFI image
+ * @v parent		Parent device path
+ * @ret path		Device path, or NULL on failure
+ *
+ * The caller must eventually free() the device path.
+ */
+static EFI_DEVICE_PATH_PROTOCOL *
+efi_image_path ( struct image *image, EFI_DEVICE_PATH_PROTOCOL *parent ) {
+	EFI_DEVICE_PATH_PROTOCOL *path;
+	FILEPATH_DEVICE_PATH *filepath;
+	EFI_DEVICE_PATH_PROTOCOL *end;
+	size_t name_len;
+	size_t prefix_len;
+	size_t filepath_len;
+	size_t len;
+
+	/* Calculate device path lengths */
+	end = efi_devpath_end ( parent );
+	prefix_len = ( ( void * ) end - ( void * ) parent );
+	name_len = strlen ( image->name );
+	filepath_len = ( SIZE_OF_FILEPATH_DEVICE_PATH +
+			 ( name_len + 1 /* NUL */ ) * sizeof ( wchar_t ) );
+	len = ( prefix_len + filepath_len + sizeof ( *end ) );
+
+	/* Allocate device path */
+	path = zalloc ( len );
+	if ( ! path )
+		return NULL;
+
+	/* Construct device path */
+	memcpy ( path, parent, prefix_len );
+	filepath = ( ( ( void * ) path ) + prefix_len );
+	filepath->Header.Type = MEDIA_DEVICE_PATH;
+	filepath->Header.SubType = MEDIA_FILEPATH_DP;
+	filepath->Header.Length[0] = ( filepath_len & 0xff );
+	filepath->Header.Length[1] = ( filepath_len >> 8 );
+	efi_snprintf ( filepath->PathName, ( name_len + 1 /* NUL */ ),
+		       "%s", image->name );
+	end = ( ( ( void * ) filepath ) + filepath_len );
+	end->Type = END_DEVICE_PATH_TYPE;
+	end->SubType = END_ENTIRE_DEVICE_PATH_SUBTYPE;
+	end->Length[0] = sizeof ( *end );
+
+	return path;
+}
+
+/**
+ * Create command line for image
+ *
+ * @v image             EFI image
+ * @ret cmdline		Command line, or NULL on failure
+ */
+static wchar_t * efi_image_cmdline ( struct image *image ) {
+	wchar_t *cmdline;
+	size_t len;
+
+	len = ( strlen ( image->name ) +
+		( image->cmdline ?
+		  ( 1 /* " " */ + strlen ( image->cmdline ) ) : 0 ) );
+	cmdline = zalloc ( ( len + 1 /* NUL */ ) * sizeof ( wchar_t ) );
+	if ( ! cmdline )
+		return NULL;
+	efi_snprintf ( cmdline, ( len + 1 /* NUL */ ), "%s%s%s",
+		       image->name,
+		       ( image->cmdline ? " " : "" ),
+		       ( image->cmdline ? image->cmdline : "" ) );
+	return cmdline;
+}
+
 /**
  * Execute EFI image
  *
@@ -34,35 +119,120 @@ FEATURE ( FEATURE_IMAGE, "EFI", DHCP_EB_FEATURE_EFI, 1 );
  */
 static int efi_image_exec ( struct image *image ) {
 	EFI_BOOT_SERVICES *bs = efi_systab->BootServices;
+	struct efi_snp_device *snpdev;
+	EFI_DEVICE_PATH_PROTOCOL *path;
+	union {
+		EFI_LOADED_IMAGE_PROTOCOL *image;
+		void *interface;
+	} loaded;
 	EFI_HANDLE handle;
-	UINTN exit_data_size;
-	CHAR16 *exit_data;
+	wchar_t *cmdline;
 	EFI_STATUS efirc;
 	int rc;
 
+	/* Find an appropriate device handle to use */
+	snpdev = last_opened_snpdev();
+	if ( ! snpdev ) {
+		DBGC ( image, "EFIIMAGE %p could not identify SNP device\n",
+		       image );
+		rc = -ENODEV;
+		goto err_no_snpdev;
+	}
+
+	/* Install file I/O protocols */
+	if ( ( rc = efi_file_install ( &snpdev->handle ) ) != 0 ) {
+		DBGC ( image, "EFIIMAGE %p could not install file protocol: "
+		       "%s\n", image, strerror ( rc ) );
+		goto err_file_install;
+	}
+
+	/* Install iPXE download protocol */
+	if ( ( rc = efi_download_install ( &snpdev->handle ) ) != 0 ) {
+		DBGC ( image, "EFIIMAGE %p could not install iPXE download "
+		       "protocol: %s\n", image, strerror ( rc ) );
+		goto err_download_install;
+	}
+
+	/* Create device path for image */
+	path = efi_image_path ( image, &snpdev->path );
+	if ( ! path ) {
+		DBGC ( image, "EFIIMAGE %p could not create device path\n",
+		       image );
+		rc = -ENOMEM;
+		goto err_image_path;
+	}
+
+	/* Create command line for image */
+	cmdline = efi_image_cmdline ( image );
+	if ( ! cmdline ) {
+		DBGC ( image, "EFIIMAGE %p could not create command line\n",
+		       image );
+		rc = -ENOMEM;
+		goto err_cmdline;
+	}
+
 	/* Attempt loading image */
-	if ( ( efirc = bs->LoadImage ( FALSE, efi_image_handle, NULL,
+	if ( ( efirc = bs->LoadImage ( FALSE, efi_image_handle, path,
 				       user_to_virt ( image->data, 0 ),
 				       image->len, &handle ) ) != 0 ) {
 		/* Not an EFI image */
 		DBGC ( image, "EFIIMAGE %p could not load: %s\n",
 		       image, efi_strerror ( efirc ) );
-		return -ENOEXEC;
+		rc = -ENOEXEC;
+		goto err_load_image;
 	}
 
+	/* Get the loaded image protocol for the newly loaded image */
+	efirc = bs->OpenProtocol ( handle, &efi_loaded_image_protocol_guid,
+				   &loaded.interface, efi_image_handle,
+				   NULL, EFI_OPEN_PROTOCOL_GET_PROTOCOL );
+	if ( efirc ) {
+		/* Should never happen */
+		rc = EFIRC_TO_RC ( efirc );
+		goto err_open_protocol;
+	}
+
+	/* Sanity checks */
+	assert ( loaded.image->ParentHandle == efi_image_handle );
+	assert ( loaded.image->DeviceHandle == snpdev->handle );
+	assert ( loaded.image->LoadOptionsSize == 0 );
+	assert ( loaded.image->LoadOptions == NULL );
+
+	/* Set command line */
+	loaded.image->LoadOptions = cmdline;
+	loaded.image->LoadOptionsSize =
+		( ( wcslen ( cmdline ) + 1 /* NUL */ ) * sizeof ( wchar_t ) );
+
 	/* Start the image */
-	if ( ( efirc = bs->StartImage ( handle, &exit_data_size,
-					&exit_data ) ) != 0 ) {
+	if ( ( efirc = bs->StartImage ( handle, NULL, NULL ) ) != 0 ) {
 		DBGC ( image, "EFIIMAGE %p returned with status %s\n",
 		       image, efi_strerror ( efirc ) );
+		rc = EFIRC_TO_RC ( efirc );
+		goto err_start_image;
 	}
-	rc = EFIRC_TO_RC ( efirc );
 
+	/* Success */
+	rc = 0;
+
+ err_start_image:
+ err_open_protocol:
 	/* Unload the image.  We can't leave it loaded, because we
 	 * have no "unload" operation.
 	 */
-	bs->UnloadImage ( handle );
-
+	if ( ( efirc = bs->UnloadImage ( handle ) ) != 0 ) {
+		DBGC ( image, "EFIIMAGE %p could not unload: %s\n",
+		       image, efi_strerror ( efirc ) );
+	}
+ err_load_image:
+	free ( cmdline );
+ err_cmdline:
+	free ( path );
+ err_image_path:
+	efi_download_uninstall ( snpdev->handle );
+ err_download_install:
+	efi_file_uninstall ( snpdev->handle );
+ err_file_install:
+ err_no_snpdev:
 	return rc;
 }
 
diff --git a/roms/ipxe/src/image/elf.c b/roms/ipxe/src/image/elf.c
index 406a8d477c2b345c5dd7e336415a..51636a8e9437776ec8af9a0238c7 100644
--- a/roms/ipxe/src/image/elf.c
+++ b/roms/ipxe/src/image/elf.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -38,6 +39,7 @@ FILE_LICENCE ( GPL2_OR_LATER );
 typedef Elf32_Ehdr	Elf_Ehdr;
 typedef Elf32_Phdr	Elf_Phdr;
 typedef Elf32_Off	Elf_Off;
+#define ELFCLASS	ELFCLASS32
 
 /**
  * Load ELF segment into memory
@@ -46,11 +48,14 @@ typedef Elf32_Off	Elf_Off;
  * @v phdr		ELF program header
  * @v ehdr		ELF executable header
  * @ret entry		Entry point, if found
+ * @ret max		Maximum used address
  * @ret rc		Return status code
  */
 static int elf_load_segment ( struct image *image, Elf_Phdr *phdr,
-			      Elf_Ehdr *ehdr, physaddr_t *entry ) {
+			      Elf_Ehdr *ehdr, physaddr_t *entry,
+			      physaddr_t *max ) {
 	physaddr_t dest;
+	physaddr_t end;
 	userptr_t buffer;
 	unsigned long e_offset;
 	int rc;
@@ -78,6 +83,7 @@ static int elf_load_segment ( struct image *image, Elf_Phdr *phdr,
 		return -ENOEXEC;
 	}
 	buffer = phys_to_user ( dest );
+	end = ( dest + phdr->p_memsz );
 
 	DBGC ( image, "ELF %p loading segment [%x,%x) to [%x,%x,%x)\n", image,
 	       phdr->p_offset, ( phdr->p_offset + phdr->p_filesz ),
@@ -92,6 +98,10 @@ static int elf_load_segment ( struct image *image, Elf_Phdr *phdr,
 		return rc;
 	}
 
+	/* Update maximum used address, if applicable */
+	if ( end > *max )
+		*max = end;
+
 	/* Copy image to segment */
 	memcpy_user ( buffer, 0, image->data, phdr->p_offset, phdr->p_filesz );
 
@@ -118,9 +128,17 @@ static int elf_load_segment ( struct image *image, Elf_Phdr *phdr,
  *
  * @v image		ELF file
  * @ret entry		Entry point
+ * @ret max		Maximum used address
  * @ret rc		Return status code
  */
-int elf_load ( struct image *image, physaddr_t *entry ) {
+int elf_load ( struct image *image, physaddr_t *entry, physaddr_t *max ) {
+	static const uint8_t e_ident[] = {
+		[EI_MAG0]	= ELFMAG0,
+		[EI_MAG1]	= ELFMAG1,
+		[EI_MAG2]	= ELFMAG2,
+		[EI_MAG3]	= ELFMAG3,
+		[EI_CLASS]	= ELFCLASS,
+	};
 	Elf_Ehdr ehdr;
 	Elf_Phdr phdr;
 	Elf_Off phoff;
@@ -129,11 +147,15 @@ int elf_load ( struct image *image, physaddr_t *entry ) {
 
 	/* Read ELF header */
 	copy_from_user ( &ehdr, image->data, 0, sizeof ( ehdr ) );
-	if ( memcmp ( &ehdr.e_ident[EI_MAG0], ELFMAG, SELFMAG ) != 0 ) {
+	if ( memcmp ( &ehdr.e_ident[EI_MAG0], e_ident,
+		      sizeof ( e_ident ) ) != 0 ) {
 		DBGC ( image, "ELF %p has invalid signature\n", image );
 		return -ENOEXEC;
 	}
 
+	/* Initialise maximum used address */
+	*max = 0;
+
 	/* Invalidate entry point */
 	*entry = 0;
 
@@ -147,7 +169,7 @@ int elf_load ( struct image *image, physaddr_t *entry ) {
 		}
 		copy_from_user ( &phdr, image->data, phoff, sizeof ( phdr ) );
 		if ( ( rc = elf_load_segment ( image, &phdr, &ehdr,
-					       entry ) ) != 0 ) {
+					       entry, max ) ) != 0 ) {
 			return rc;
 		}
 	}
diff --git a/roms/ipxe/src/image/script.c b/roms/ipxe/src/image/script.c
index 161ac682e7cc650cabd80261910d..e83180ab55f55ec9f830c4125334 100644
--- a/roms/ipxe/src/image/script.c
+++ b/roms/ipxe/src/image/script.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -58,6 +59,7 @@ static int process_script ( struct image *image,
 			    int ( * terminate ) ( int rc ) ) {
 	off_t eol;
 	size_t len;
+	char *line;
 	int rc;
 
 	script_offset = 0;
@@ -71,23 +73,23 @@ static int process_script ( struct image *image,
 			eol = image->len;
 		len = ( eol - script_offset );
 
-		/* Copy line, terminate with NUL, and execute command */
-		{
-			char cmdbuf[ len + 1 ];
+		/* Allocate buffer for line */
+		line = zalloc ( len + 1 /* NUL */ );
+		if ( ! line )
+			return -ENOMEM;
 
-			copy_from_user ( cmdbuf, image->data,
-					 script_offset, len );
-			cmdbuf[len] = '\0';
-			DBG ( "$ %s\n", cmdbuf );
+		/* Copy line */
+		copy_from_user ( line, image->data, script_offset, len );
+		DBG ( "$ %s\n", line );
 
-			/* Move to next line */
-			script_offset += ( len + 1 );
+		/* Move to next line */
+		script_offset += ( len + 1 );
 
-			/* Process line */
-			rc = process_line ( cmdbuf );
-			if ( terminate ( rc ) )
-				return rc;
-		}
+		/* Process and free line */
+		rc = process_line ( line );
+		free ( line );
+		if ( terminate ( rc ) )
+			return rc;
 
 	} while ( script_offset < image->len );
 
@@ -221,11 +223,17 @@ static const char *goto_label;
  * @ret rc		Return status code
  */
 static int goto_find_label ( const char *line ) {
+	size_t len = strlen ( goto_label );
 
 	if ( line[0] != ':' )
 		return -ENOENT;
-	if ( strcmp ( goto_label, &line[1] ) != 0 )
+
+	if ( strncmp ( goto_label, &line[1], len ) != 0 )
+		return -ENOENT;
+
+	if ( line[ 1 + len ] && ! isspace ( line[ 1 + len ] ) )
 		return -ENOENT;
+
 	return 0;
 }
 
@@ -296,7 +304,7 @@ struct prompt_options {
 /** "prompt" option list */
 static struct option_descriptor prompt_opts[] = {
 	OPTION_DESC ( "key", 'k', required_argument,
-		      struct prompt_options, key, parse_integer ),
+		      struct prompt_options, key, parse_key ),
 	OPTION_DESC ( "timeout", 't', required_argument,
 		      struct prompt_options, timeout, parse_integer ),
 };
diff --git a/roms/ipxe/src/image/segment.c b/roms/ipxe/src/image/segment.c
index 97f6a9959454eccd81de7e795c81..86fe426628919f81837f90c2990c 100644
--- a/roms/ipxe/src/image/segment.c
+++ b/roms/ipxe/src/image/segment.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/include/assert.h b/roms/ipxe/src/include/assert.h
index 40a00a2b1008c1d88b7bf38a099a..655cbdc03e14aa7eee12a41f2041 100644
--- a/roms/ipxe/src/include/assert.h
+++ b/roms/ipxe/src/include/assert.h
@@ -18,6 +18,8 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #define ASSERTING 1
 #endif
 
+extern unsigned int assertion_failures;
+
 /** printf() for assertions
  *
  * This function exists so that the assert() macro can expand to
@@ -43,6 +45,7 @@ assert_printf ( const char *fmt, ... ) asm ( "printf" );
 #define assert( condition ) 						     \
 	do { 								     \
 		if ( ASSERTING && ! (condition) ) { 			     \
+			assertion_failures++;				     \
 			assert_printf ( "assert(%s) failed at %s line %d\n", \
 					#condition, __FILE__, __LINE__ );    \
 		} 							     \
diff --git a/roms/ipxe/src/include/compiler.h b/roms/ipxe/src/include/compiler.h
index feea5167ec04113e76ba0cd38282..ed9af237d01adac8f351a545d34c 100644
--- a/roms/ipxe/src/include/compiler.h
+++ b/roms/ipxe/src/include/compiler.h
@@ -260,19 +260,9 @@ REQUEST_EXPANDED ( CONFIG_SYMBOL );
 
 #ifndef ASSEMBLY
 
-/** printf() for debugging
- *
- * This function exists so that the DBG() macros can expand to
- * printf() calls without dragging the printf() prototype into scope.
- *
- * As far as the compiler is concerned, dbg_printf() and printf() are
- * completely unrelated calls; it's only at the assembly stage that
- * references to the dbg_printf symbol are collapsed into references
- * to the printf symbol.
- */
-extern int __attribute__ (( format ( printf, 1, 2 ) )) 
-dbg_printf ( const char *fmt, ... ) asm ( "printf" );
-
+/** printf() for debugging */
+extern void __attribute__ (( format ( printf, 1, 2 ) ))
+dbg_printf ( const char *fmt, ... );
 extern void dbg_autocolourise ( unsigned long id );
 extern void dbg_decolourise ( void );
 extern void dbg_hex_dump_da ( unsigned long dispaddr,
@@ -339,6 +329,7 @@ int __debug_disable;
 				unsigned long ul;		\
 				typeof ( dispaddr ) raw;	\
 			} da;					\
+			da.ul = 0;				\
 			da.raw = dispaddr;			\
 			dbg_hex_dump_da ( da.ul, data, len );	\
 		}						\
@@ -370,6 +361,7 @@ int __debug_disable;
 				unsigned long ul;		\
 				typeof ( dispaddr ) raw;	\
 			} da;					\
+			da.ul = 0;				\
 			da.raw = dispaddr;			\
 			dbg_md5_da ( da.ul, data, len );	\
 		}						\
@@ -421,6 +413,7 @@ int __debug_disable;
 				unsigned long ul;		\
 				typeof ( id ) raw;		\
 			} dbg_stream;				\
+			dbg_stream.ul = 0;			\
 			dbg_stream.raw = id;			\
 			dbg_autocolourise ( dbg_stream.ul );	\
 		}						\
diff --git a/roms/ipxe/src/include/errno.h b/roms/ipxe/src/include/errno.h
index a86573fc9f9aaf4f4a99fc4568d5..bd4ddaf41be6becc0564f08e460a 100644
--- a/roms/ipxe/src/include/errno.h
+++ b/roms/ipxe/src/include/errno.h
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 #ifndef ERRNO_H
diff --git a/roms/ipxe/src/include/etherboot.h b/roms/ipxe/src/include/etherboot.h
index b2fbe4f67639880a28f79a2acb34..ba79cb16ac60474b96489a097dc0 100644
--- a/roms/ipxe/src/include/etherboot.h
+++ b/roms/ipxe/src/include/etherboot.h
@@ -14,7 +14,6 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #include <stdio.h>
 #include <unistd.h>
 #include <strings.h>
-#include <ipxe/console.h>
 #include <ipxe/timer.h>
 #include <ipxe/if_arp.h>
 #include <ipxe/if_ether.h>
diff --git a/roms/ipxe/src/include/hci/ifmgmt_cmd.h b/roms/ipxe/src/include/hci/ifmgmt_cmd.h
index a7751cb287c03b83aff54004d2cc..abdb27f43a0a55f36b8d5358e8ad 100644
--- a/roms/ipxe/src/include/hci/ifmgmt_cmd.h
+++ b/roms/ipxe/src/include/hci/ifmgmt_cmd.h
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 #ifndef _IFMGMT_CMD_H
diff --git a/roms/ipxe/src/include/ipxe/aes.h b/roms/ipxe/src/include/ipxe/aes.h
index 5d645b207f706aef0de670aa838f..4e44f9853671d87a72197a21a471 100644
--- a/roms/ipxe/src/include/ipxe/aes.h
+++ b/roms/ipxe/src/include/ipxe/aes.h
@@ -21,6 +21,10 @@ struct aes_context {
 /** AES context size */
 #define AES_CTX_SIZE sizeof ( struct aes_context )
 
+/* AXTLS functions */
+extern void axtls_aes_encrypt ( const AES_CTX *ctx, uint32_t *data );
+extern void axtls_aes_decrypt ( const AES_CTX *ctx, uint32_t *data );
+
 extern struct cipher_algorithm aes_algorithm;
 extern struct cipher_algorithm aes_cbc_algorithm;
 
diff --git a/roms/ipxe/src/include/ipxe/ansiesc.h b/roms/ipxe/src/include/ipxe/ansiesc.h
index 35438e43a593b768d9975b958e0d..c00af258a8aa69cc5bf768de1277 100644
--- a/roms/ipxe/src/include/ipxe/ansiesc.h
+++ b/roms/ipxe/src/include/ipxe/ansiesc.h
@@ -113,6 +113,13 @@ struct ansiesc_context {
 /** Select graphic rendition */
 #define ANSIESC_SGR 'm'
 
+/** Explicit log message priority
+ *
+ * This is an iPXE private sequence identifier.  (The range 'p' to '~'
+ * is reserved for private sequences.)
+ */
+#define ANSIESC_LOG_PRIORITY 'p'
+
 /** @} */
 
 extern int ansiesc_process ( struct ansiesc_context *ctx, int c );
diff --git a/roms/ipxe/src/include/ipxe/arp.h b/roms/ipxe/src/include/ipxe/arp.h
index f7b99c68da04a003fa5b6e3a932f..00396d8214dfa4395adc3785f8f8 100644
--- a/roms/ipxe/src/include/ipxe/arp.h
+++ b/roms/ipxe/src/include/ipxe/arp.h
@@ -35,10 +35,8 @@ struct arp_net_protocol {
 
 extern struct net_protocol arp_protocol __net_protocol;
 
-extern int arp_resolve ( struct net_device *netdev,
-			 struct net_protocol *net_protocol,
-			 const void *dest_net_addr,
-			 const void *source_net_addr,
-			 void *dest_ll_addr );
+extern int arp_tx ( struct io_buffer *iobuf, struct net_device *netdev,
+		    struct net_protocol *net_protocol, const void *net_dest,
+		    const void *net_source, const void *ll_source );
 
 #endif /* _IPXE_ARP_H */
